package com.excubivue.cubivue_scanners_example

import android.content.ActivityNotFoundException
import android.content.Intent
import android.os.Bundle
import android.util.Log
import com.excubivue.cubivue_scanners.CubivueScannersPlugin
import com.excubivue.cubivue_scanners.scanner.ScannerHelper
import com.excubivue.cubivue_scanners.scanner.models.ScanResult
import com.excubivue.cubivue_scanners.scanner.utils.ScannerType
import io.flutter.embedding.android.FlutterActivity

class MainActivity : FlutterActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        //Initialize Scanner
        ScannerHelper.init(this)
    }

    public override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {

        ScannerHelper.parseZXingResult(resultCode, data)?.let {
            Log.i("parseZXingResult", "onActivityResult: $it")
            CubivueScannersPlugin.eventSink?.success(ScanResult(it, ScannerType.ZXING.value).toString())
        }
        super.onActivityResult(requestCode, resultCode, data)
    }

}
